﻿using System;
using System.ComponentModel;
using System.Drawing;
using System.Collections.Generic; // Added
using System.Windows.Forms;
using Fidelity.Components;
using CtrlLib;
using WealthLab;
using WealthLab.PosSizers;
using WealthLab.Indicators;

namespace Abacus.PosSizers
{
    public class Abacus : UserControl
    {
        private IContainer components = null;
        private GroupBox gb1;
        private GroupBox gb2;
        private Label volumePercentLabel;
        private Label daysToAverageLabel;
        private NumericUpDown percentOfAverageVolume;
        private Label label2;
        private ComboBox cashForFirstTradesIndex;
        private CheckBox skippedTradeSolutionChecked;
        private RadioButton spreadCashEqually;
        private Label label1;
        private NumericUpDown percentOfCashValue;
        private NumericUpDown fixedDollarValue;
        private Label label4;
        private RadioButton percentOfCashChecked;
        private RadioButton fixedDollarChecked;
        private Label label6;
        private Label label5;
        private NumericUpDown daysToAverage;

        public Abacus()
        {
            this.InitializeComponent();
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.gb1 = new System.Windows.Forms.GroupBox();
            this.label6 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.percentOfCashValue = new System.Windows.Forms.NumericUpDown();
            this.fixedDollarValue = new System.Windows.Forms.NumericUpDown();
            this.label4 = new System.Windows.Forms.Label();
            this.percentOfCashChecked = new System.Windows.Forms.RadioButton();
            this.fixedDollarChecked = new System.Windows.Forms.RadioButton();
            this.spreadCashEqually = new System.Windows.Forms.RadioButton();
            this.skippedTradeSolutionChecked = new System.Windows.Forms.CheckBox();
            this.label2 = new System.Windows.Forms.Label();
            this.cashForFirstTradesIndex = new System.Windows.Forms.ComboBox();
            this.gb2 = new System.Windows.Forms.GroupBox();
            this.label1 = new System.Windows.Forms.Label();
            this.percentOfAverageVolume = new System.Windows.Forms.NumericUpDown();
            this.daysToAverage = new System.Windows.Forms.NumericUpDown();
            this.volumePercentLabel = new System.Windows.Forms.Label();
            this.daysToAverageLabel = new System.Windows.Forms.Label();
            this.gb1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.percentOfCashValue)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.fixedDollarValue)).BeginInit();
            this.gb2.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.percentOfAverageVolume)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.daysToAverage)).BeginInit();
            this.SuspendLayout();
            // 
            // gb1
            // 
            this.gb1.Controls.Add(this.label6);
            this.gb1.Controls.Add(this.label5);
            this.gb1.Controls.Add(this.percentOfCashValue);
            this.gb1.Controls.Add(this.fixedDollarValue);
            this.gb1.Controls.Add(this.label4);
            this.gb1.Controls.Add(this.percentOfCashChecked);
            this.gb1.Controls.Add(this.fixedDollarChecked);
            this.gb1.Controls.Add(this.spreadCashEqually);
            this.gb1.Controls.Add(this.skippedTradeSolutionChecked);
            this.gb1.Controls.Add(this.label2);
            this.gb1.Controls.Add(this.cashForFirstTradesIndex);
            this.gb1.Location = new System.Drawing.Point(3, 3);
            this.gb1.Name = "gb1";
            this.gb1.Size = new System.Drawing.Size(214, 170);
            this.gb1.TabIndex = 0;
            this.gb1.TabStop = false;
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(193, 70);
            this.label6.Margin = new System.Windows.Forms.Padding(0);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(15, 13);
            this.label6.TabIndex = 26;
            this.label6.Text = "%";
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Location = new System.Drawing.Point(106, 47);
            this.label5.Margin = new System.Windows.Forms.Padding(0);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(13, 13);
            this.label5.TabIndex = 25;
            this.label5.Text = "$";
            this.label5.TextAlign = System.Drawing.ContentAlignment.TopRight;
            // 
            // percentOfCashValue
            // 
            this.percentOfCashValue.Cursor = System.Windows.Forms.Cursors.Default;
            this.percentOfCashValue.Increment = new decimal(new int[] {
            5,
            0,
            0,
            0});
            this.percentOfCashValue.Location = new System.Drawing.Point(154, 68);
            this.percentOfCashValue.Margin = new System.Windows.Forms.Padding(0);
            this.percentOfCashValue.Minimum = new decimal(new int[] {
            5,
            0,
            0,
            0});
            this.percentOfCashValue.Name = "percentOfCashValue";
            this.percentOfCashValue.Size = new System.Drawing.Size(39, 20);
            this.percentOfCashValue.TabIndex = 24;
            this.percentOfCashValue.Value = new decimal(new int[] {
            10,
            0,
            0,
            0});
            // 
            // fixedDollarValue
            // 
            this.fixedDollarValue.Increment = new decimal(new int[] {
            100000,
            0,
            0,
            0});
            this.fixedDollarValue.Location = new System.Drawing.Point(119, 45);
            this.fixedDollarValue.Margin = new System.Windows.Forms.Padding(0);
            this.fixedDollarValue.Maximum = new decimal(new int[] {
            5000000,
            0,
            0,
            0});
            this.fixedDollarValue.Minimum = new decimal(new int[] {
            10000,
            0,
            0,
            0});
            this.fixedDollarValue.Name = "fixedDollarValue";
            this.fixedDollarValue.Size = new System.Drawing.Size(74, 20);
            this.fixedDollarValue.TabIndex = 23;
            this.fixedDollarValue.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.fixedDollarValue.ThousandsSeparator = true;
            this.fixedDollarValue.Value = new decimal(new int[] {
            1000000,
            0,
            0,
            0});
            // 
            // label4
            // 
            this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label4.Location = new System.Drawing.Point(5, 9);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(206, 33);
            this.label4.TabIndex = 22;
            this.label4.Text = "All options are limited by Cash and Percent of Average Volume";
            this.label4.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            // 
            // percentOfCashChecked
            // 
            this.percentOfCashChecked.AutoSize = true;
            this.percentOfCashChecked.Location = new System.Drawing.Point(6, 68);
            this.percentOfCashChecked.Name = "percentOfCashChecked";
            this.percentOfCashChecked.Size = new System.Drawing.Size(103, 17);
            this.percentOfCashChecked.TabIndex = 21;
            this.percentOfCashChecked.TabStop = true;
            this.percentOfCashChecked.Text = "Percent Of Cash";
            this.percentOfCashChecked.UseVisualStyleBackColor = true;
            // 
            // fixedDollarChecked
            // 
            this.fixedDollarChecked.AutoSize = true;
            this.fixedDollarChecked.Location = new System.Drawing.Point(6, 45);
            this.fixedDollarChecked.Name = "fixedDollarChecked";
            this.fixedDollarChecked.Size = new System.Drawing.Size(80, 17);
            this.fixedDollarChecked.TabIndex = 20;
            this.fixedDollarChecked.TabStop = true;
            this.fixedDollarChecked.Text = "Fixed Dollar";
            this.fixedDollarChecked.UseVisualStyleBackColor = true;
            // 
            // spreadCashEqually
            // 
            this.spreadCashEqually.AutoSize = true;
            this.spreadCashEqually.Location = new System.Drawing.Point(6, 91);
            this.spreadCashEqually.Name = "spreadCashEqually";
            this.spreadCashEqually.Size = new System.Drawing.Size(123, 17);
            this.spreadCashEqually.TabIndex = 16;
            this.spreadCashEqually.TabStop = true;
            this.spreadCashEqually.Text = "Spread Cash Equally";
            this.spreadCashEqually.UseVisualStyleBackColor = true;
            // 
            // skippedTradeSolutionChecked
            // 
            this.skippedTradeSolutionChecked.AutoSize = true;
            this.skippedTradeSolutionChecked.Location = new System.Drawing.Point(6, 117);
            this.skippedTradeSolutionChecked.Name = "skippedTradeSolutionChecked";
            this.skippedTradeSolutionChecked.Size = new System.Drawing.Size(137, 17);
            this.skippedTradeSolutionChecked.TabIndex = 15;
            this.skippedTradeSolutionChecked.Text = "Skipped Trade Solution";
            this.skippedTradeSolutionChecked.UseVisualStyleBackColor = true;
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
            this.label2.Location = new System.Drawing.Point(25, 143);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(104, 13);
            this.label2.TabIndex = 11;
            this.label2.Text = "Cash for First Trades";
            this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // cashForFirstTradesIndex
            // 
            this.cashForFirstTradesIndex.DisplayMember = "0";
            this.cashForFirstTradesIndex.FormattingEnabled = true;
            this.cashForFirstTradesIndex.Items.AddRange(new object[] {
            "100%",
            "50%"});
            this.cashForFirstTradesIndex.Location = new System.Drawing.Point(135, 140);
            this.cashForFirstTradesIndex.Name = "cashForFirstTradesIndex";
            this.cashForFirstTradesIndex.Size = new System.Drawing.Size(59, 21);
            this.cashForFirstTradesIndex.TabIndex = 9;
            this.cashForFirstTradesIndex.ValueMember = "1";
            // 
            // gb2
            // 
            this.gb2.Controls.Add(this.label1);
            this.gb2.Controls.Add(this.percentOfAverageVolume);
            this.gb2.Controls.Add(this.daysToAverage);
            this.gb2.Controls.Add(this.volumePercentLabel);
            this.gb2.Controls.Add(this.daysToAverageLabel);
            this.gb2.Location = new System.Drawing.Point(0, 179);
            this.gb2.Name = "gb2";
            this.gb2.Size = new System.Drawing.Size(215, 77);
            this.gb2.TabIndex = 1;
            this.gb2.TabStop = false;
            this.gb2.Text = "Average Volume";
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(194, 22);
            this.label1.Margin = new System.Windows.Forms.Padding(0);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(15, 13);
            this.label1.TabIndex = 4;
            this.label1.Text = "%";
            // 
            // percentOfAverageVolume
            // 
            this.percentOfAverageVolume.DecimalPlaces = 2;
            this.percentOfAverageVolume.Increment = new decimal(new int[] {
            25,
            0,
            0,
            131072});
            this.percentOfAverageVolume.Location = new System.Drawing.Point(144, 19);
            this.percentOfAverageVolume.Margin = new System.Windows.Forms.Padding(0);
            this.percentOfAverageVolume.Maximum = new decimal(new int[] {
            5,
            0,
            0,
            0});
            this.percentOfAverageVolume.Minimum = new decimal(new int[] {
            5,
            0,
            0,
            65536});
            this.percentOfAverageVolume.Name = "percentOfAverageVolume";
            this.percentOfAverageVolume.Size = new System.Drawing.Size(50, 20);
            this.percentOfAverageVolume.TabIndex = 0;
            this.percentOfAverageVolume.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.percentOfAverageVolume.Value = new decimal(new int[] {
            15,
            0,
            0,
            65536});
            // 
            // daysToAverage
            // 
            this.daysToAverage.Location = new System.Drawing.Point(144, 48);
            this.daysToAverage.Maximum = new decimal(new int[] {
            20,
            0,
            0,
            0});
            this.daysToAverage.Minimum = new decimal(new int[] {
            2,
            0,
            0,
            0});
            this.daysToAverage.Name = "daysToAverage";
            this.daysToAverage.Size = new System.Drawing.Size(50, 20);
            this.daysToAverage.TabIndex = 1;
            this.daysToAverage.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.daysToAverage.Value = new decimal(new int[] {
            10,
            0,
            0,
            0});
            // 
            // volumePercentLabel
            // 
            this.volumePercentLabel.Location = new System.Drawing.Point(3, 22);
            this.volumePercentLabel.Name = "volumePercentLabel";
            this.volumePercentLabel.Size = new System.Drawing.Size(150, 18);
            this.volumePercentLabel.TabIndex = 2;
            this.volumePercentLabel.Text = "Percent of Average Volume";
            // 
            // daysToAverageLabel
            // 
            this.daysToAverageLabel.Location = new System.Drawing.Point(3, 50);
            this.daysToAverageLabel.Name = "daysToAverageLabel";
            this.daysToAverageLabel.Size = new System.Drawing.Size(110, 18);
            this.daysToAverageLabel.TabIndex = 3;
            this.daysToAverageLabel.Text = "Days to Average";
            // 
            // Abacus
            // 
            this.BackColor = System.Drawing.SystemColors.Control;
            this.Controls.Add(this.gb1);
            this.Controls.Add(this.gb2);
            this.Name = "Abacus";
            this.Size = new System.Drawing.Size(217, 262);
            this.gb1.ResumeLayout(false);
            this.gb1.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.percentOfCashValue)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.fixedDollarValue)).EndInit();
            this.gb2.ResumeLayout(false);
            this.gb2.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.percentOfAverageVolume)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.daysToAverage)).EndInit();
            this.ResumeLayout(false);

        }
        public bool FixedDollarChecked
        {
            get
            {
                return (bool)this.fixedDollarChecked.Checked;
            }
            set
            {
                this.fixedDollarChecked.Checked = value;
            }
        }
        public double FixedDollarValue
        {
            get
            {
                return (int)this.fixedDollarValue.Value;
            }
            set
            {
                this.fixedDollarValue.Text = value.ToString();
            }
        }
        public bool PercentOfCashChecked
        {
            get
            {
                return (bool)this.percentOfCashChecked.Checked;
            }
            set
            {
                this.percentOfCashChecked.Checked = value;
            }
        }
        public double PercentOfCashValue
        {
            get
            {
                return (int)this.percentOfCashValue.Value;
            }
            set
            {
                this.percentOfCashValue.Text = value.ToString();
            }
        }
        public bool SpreadCashEqually
        {
            get
            {
                return (bool)this.spreadCashEqually.Checked;
            }
            set
            {
                this.spreadCashEqually.Checked = value;
            }
        }
        public int CashForFirstTradesIndex
        {
            get
            {
                return (int)this.cashForFirstTradesIndex.SelectedIndex;
            }
            set
            {
                this.cashForFirstTradesIndex.SelectedIndex = value;
            }
        }
        public bool SkippedTradeSolution
        {
            get
            {
                return (bool)this.skippedTradeSolutionChecked.Checked;
            }
            set
            {
                this.skippedTradeSolutionChecked.Checked = value;
            }
        }
        public double PercentOfAverageVolume
        {
            get
            {
                return (double)this.percentOfAverageVolume.Value;
            }
            set
            {
                this.percentOfAverageVolume.Text = value.ToString();
            }
        }
        public int DaysToAverage
        {
            get
            {
                return (int)this.daysToAverage.Value;
            }
            set
            {
                this.daysToAverage.Text = value.ToString();
            }
        }
    }

    public class AbacusPosSizer : PosSizer, ICustomSettings
    {
        private bool _fixedDollarChecked = true;
        private double _fixedDollarValue = 100000;
        private bool _percentOfCashChecked = false;
        private double _percentOfCashValue = 10;
        private bool _spreadCashEqually = false;
        private int _cashForFirstTradesIndex = 0;
        private bool _skippedTradeSolution = false;
        private double _percentOfAverageVolume = 1.5;
        private int _daysToAverage = 10;

        private Abacus _settings = new Abacus();

        public override double SizePosition(Position currentPos, Bars bars, int bar, double basisPrice, PositionType pt, double riskStopLevel, double equity, double cash)
        {
            // Get commission
            SettingsManager sm = new SettingsManager();
            sm.RootPath = Application.UserAppDataPath + System.IO.Path.DirectorySeparatorChar + "Data";
            sm.FileName = "WealthLabConfig.txt";
            sm.LoadSettings();
            double commission;
            string commissionType = string.Empty;
            string commissionString = string.Empty;
            if (sm.Settings.Count > 0)
            {
                commissionType = sm.Get("Commission", string.Empty);
                commissionString = sm.Get(commissionType, string.Empty);
            }
            commission = Convert.ToInt32(commissionString);
            
            int currentPosNumber = -1;
            double cashOnCurrentPosEntryDate = 0;
            double size = 0;
            DateTime currentPosEntryDate = bars.Date[bar + 1];
            DateTime firstTrade = DateTime.Now;
            int candidatesOnCurrentPosEntryDate = 0;
            double[] calculatedBasisPrice = new double[1000];
            double[] averageVolumeLimitation = new double[1000];
            double[] calculatedSize = new double[1000];
 
            // Reduce cash by commission on this trade
            cash -= commission;
            cashOnCurrentPosEntryDate = cash;
            
            // Check all Candidates
            for (int n = 0; n < Candidates.Count; n++)
            {
                // Find currentPos
                if (currentPosNumber == -1
                    && Candidates[n].Bars == bars
                    && Candidates[n].EntryDate == currentPosEntryDate
                    && Candidates[n].BasisPrice == basisPrice
                    && Candidates[n].PositionType == pt
                    && Candidates[n].Shares == 1)
                {
                    candidatesOnCurrentPosEntryDate++;
                    currentPosNumber = n;
                }

                // Find all candidates on that date
                else if (Candidates[n].EntryDate == currentPosEntryDate)
                {
                    candidatesOnCurrentPosEntryDate++;

                    // Reduce cash by commission
                    cash -= commission;

                    // Adjust cashOnCurrentPosEntryDate for already sized positions
                    if (Candidates[n].Shares > 1)
                        cashOnCurrentPosEntryDate += Candidates[n].Size - commission;
                    else
                        cashOnCurrentPosEntryDate -= commission;
                }
                // Determine the first trade date
                if (Candidates[n].EntryDate < firstTrade)
                    firstTrade = Candidates[n].EntryDate;

               // Skipped Trade Solution
                if (this._skippedTradeSolution
                    && Candidates[n].EntryBar < Candidates[n].Bars.Count)
                {
                    if (Candidates[n].EntryOrderType == OrderType.Market)
                        calculatedBasisPrice[n] = Candidates[n].Bars.Open[Candidates[n].EntryBar];
                    else if (Candidates[n].EntryOrderType == OrderType.AtClose)
                        calculatedBasisPrice[n] = Candidates[n].Bars.Close[Candidates[n].EntryBar];
                }
                else
                    calculatedBasisPrice[n] = Candidates[n].BasisPrice;
            }
            
            // Size Positions
            if (this._fixedDollarChecked)
            {
                // Use 1/2 of fixedDollarValue if only using 50% of cash on first trades
                // ADDING 33% AS AN OPTION GETS COMPLICATED, BECAUSE YOU HAVE TO REDUCE THE EQUITY ON THE SECOND TRADE ALSO
                if (currentPosEntryDate == firstTrade
                    && this._cashForFirstTradesIndex == 1)
                {
                    // Use fixedDollarValue if there is enough cash, rounded down to the nearest 100 shares
                    if (this._fixedDollarValue <= cash - cashOnCurrentPosEntryDate / 2)
                        calculatedSize[currentPosNumber] = (Math.Truncate(this._fixedDollarValue / calculatedBasisPrice[currentPosNumber] / 100) * 100);
                    else
                        calculatedSize[currentPosNumber] = (Math.Truncate((cash - cashOnCurrentPosEntryDate / 2) / calculatedBasisPrice[currentPosNumber] / 100) * 100);
                }
                else
                {
                    // Use fixedDollarValue if there is enough cash, rounded down to the nearest 100 shares
                    if (this._fixedDollarValue <= cash)
                        calculatedSize[currentPosNumber] = (Math.Truncate(this._fixedDollarValue / calculatedBasisPrice[currentPosNumber] / 100) * 100);
                    // Use available cash, rounded down to the nearest 100 shares
                    else
                        calculatedSize[currentPosNumber] = (Math.Truncate(cash / calculatedBasisPrice[currentPosNumber] / 100) * 100);
                }
            }
            else if (this._percentOfCashChecked)
            {
                // Use 1/2 of fixedDollarValue if only using 50% of cash on first trades
                // ADDING 33% AS AN OPTION GETS COMPLICATED, BECAUSE YOU HAVE TO REDUCE THE EQUITY ON THE SECOND TRADE ALSO
                if (currentPosEntryDate == firstTrade
                    && this._cashForFirstTradesIndex == 1)
                {
                    // Use percentOfCashValue if there is enough cash, rounded down to the nearest 100 shares
                    if (this._percentOfCashValue / 100 * cashOnCurrentPosEntryDate <= cash / 2)
                        calculatedSize[currentPosNumber] = Math.Truncate(this._percentOfCashValue / 100 * cashOnCurrentPosEntryDate / 2 / calculatedBasisPrice[currentPosNumber] / 100) * 100;
                    // Use available cash, rounded down to the nearest 100 shares
                    else
                        calculatedSize[currentPosNumber] = Math.Truncate((cash - cashOnCurrentPosEntryDate / 2) / calculatedBasisPrice[currentPosNumber] / 100) * 100;
                }
                else
                {
                    // Use percentOfCashValue if there is enough cash, rounded down to the nearest 100 shares
                    if (this._percentOfCashValue / 100 * cashOnCurrentPosEntryDate <= cash)
                        calculatedSize[currentPosNumber] = Math.Truncate(this._percentOfCashValue / 100 * cashOnCurrentPosEntryDate / calculatedBasisPrice[currentPosNumber] / 100) * 100;
                    // Use available cash, rounded down to the nearest 100 shares
                    else
                        calculatedSize[currentPosNumber] = Math.Truncate(cash / calculatedBasisPrice[currentPosNumber] / 100) * 100;
                }
            }
            // Spread cash equally, rounded down to the nearest 100 shares
            else
            {
                for (int n = 0; n < candidatesOnCurrentPosEntryDate; n++)
                {
                    // Size all candidates
                    if (currentPosEntryDate == firstTrade
                    && this._cashForFirstTradesIndex == 1)
                        calculatedSize[n] = Math.Truncate((cashOnCurrentPosEntryDate / 2 / candidatesOnCurrentPosEntryDate / calculatedBasisPrice[n]) / 100) * 100;
                    else
                        calculatedSize[n] = Math.Truncate((cashOnCurrentPosEntryDate / candidatesOnCurrentPosEntryDate / calculatedBasisPrice[n]) / 100) * 100;

                    // Average Volume calculation rounded down to the nearest 100 shares
                    averageVolumeLimitation[n] = Math.Truncate(this._percentOfAverageVolume / 100 * SMA.Value(Candidates[n].EntryBar - 1, Candidates[n].Bars.Volume, this._daysToAverage) / 100) * 100;
                }
                for (int n = 0; n < candidatesOnCurrentPosEntryDate; n++)
                {

                    if (averageVolumeLimitation[n] < calculatedSize[n])
                    {
                        double additionalCash = (calculatedSize[n] - averageVolumeLimitation[n]) * calculatedBasisPrice[n];

                        // No need to try to allocate remaining additionalCash more times than there are candidates
                        for (int spreadN = 0; spreadN < candidatesOnCurrentPosEntryDate; spreadN++)
                        {

                            // Stop trying to allocate when additionalCash gets small
                            // $100 on a stock at $1/share is 100 shares, which is the rounding factor
                            if (additionalCash < 100)
                                break;

                            // Portion of additionalCash to allocate to other candidates
                            double perPosition = additionalCash / (candidatesOnCurrentPosEntryDate - 1);

                            // Spread equity to other candidates
                            for (int candidateN = 0; candidateN <= candidatesOnCurrentPosEntryDate; candidateN++)
                            {
                                // Skip average volume limited positions
                                if (calculatedSize[candidateN] < averageVolumeLimitation[candidateN])
                                {

                                    if (calculatedSize[candidateN] + perPosition / calculatedBasisPrice[candidateN] < averageVolumeLimitation[candidateN])
                                    {
                                        // Increase size of position
                                        calculatedSize[candidateN] += perPosition / calculatedBasisPrice[candidateN];
                                        additionalCash -= perPosition;
                                    }
                                    else
                                    {
                                        additionalCash -= (averageVolumeLimitation[candidateN] - calculatedSize[candidateN]) * calculatedBasisPrice[candidateN];

                                        // Use additonal cash up to Average Volume Limitiation
                                        calculatedSize[candidateN] = averageVolumeLimitation[candidateN];
                                    }
                                }
                            }
                        }
                        // Reduce size of this position
                        calculatedSize[n] = averageVolumeLimitation[n];
                    }
                }
                // Round current position down to nearest 100 shares
                calculatedSize[currentPosNumber] = (Math.Truncate(calculatedSize[currentPosNumber] / 100) * 100);
            }
           
            // Average Volume calculation rounded down to the nearest 100 shares
            averageVolumeLimitation[currentPosNumber] = Math.Truncate(this._percentOfAverageVolume / 100 * SMA.Value(Candidates[currentPosNumber].EntryBar - 1, Candidates[currentPosNumber].Bars.Volume, this._daysToAverage) / 100) * 100;

            // Reduce size if necessary
            if (averageVolumeLimitation[currentPosNumber] < calculatedSize[currentPosNumber])
                calculatedSize[currentPosNumber] = averageVolumeLimitation[currentPosNumber];

            // Return size of currentPos
            size = calculatedSize[currentPosNumber];
            return size;
        }
        
        public override string GetConfigString()
        {
            return base.GetConfigString()
                + this._fixedDollarChecked + "|"
                + this._fixedDollarValue + "|"
                + this._percentOfCashChecked + "|"
                + this._percentOfCashValue + "|"
                + this._spreadCashEqually + "|"
                + this._cashForFirstTradesIndex + "|"
                + this._skippedTradeSolution + "|"
                + this._percentOfAverageVolume + "|"
                + this._daysToAverage + "|";
        }

        public override void ApplyConfigString(string config)
        {
            string[] tokens = config.Split('|');
            this._fixedDollarChecked = Boolean.Parse(tokens[0]);
            this._fixedDollarValue = Double.Parse(tokens[1]);
            this._percentOfCashChecked = Boolean.Parse(tokens[2]);
            this._percentOfCashValue = Double.Parse(tokens[3]);
            this._spreadCashEqually = Boolean.Parse(tokens[4]);
            this._cashForFirstTradesIndex = Int32.Parse(tokens[5]);
            this._skippedTradeSolution = Boolean.Parse(tokens[6]);
            this._percentOfAverageVolume = Double.Parse(tokens[7]);
            this._daysToAverage = Int32.Parse(tokens[8]);
        }

        public void ChangeSettings(UserControl ui)
        {
            this._fixedDollarChecked = this._settings.FixedDollarChecked;
            this._fixedDollarValue = this._settings.FixedDollarValue;
            this._percentOfCashChecked = this._settings.PercentOfCashChecked;
            this._percentOfCashValue = this._settings.PercentOfCashValue;
            this._spreadCashEqually = this._settings.SpreadCashEqually;
            this._cashForFirstTradesIndex = this._settings.CashForFirstTradesIndex;
            this._skippedTradeSolution = this._settings.SkippedTradeSolution;
            this._percentOfAverageVolume = this._settings.PercentOfAverageVolume;
            this._daysToAverage = this._settings.DaysToAverage;
        }

        public UserControl GetSettingsUI()
        {
            this._settings.FixedDollarChecked = this._fixedDollarChecked;
            this._settings.FixedDollarValue = this._fixedDollarValue;
            this._settings.PercentOfCashChecked = this._percentOfCashChecked;
            this._settings.PercentOfCashValue = this._percentOfCashValue;
            this._settings.SpreadCashEqually = this._spreadCashEqually;
            this._settings.CashForFirstTradesIndex = this._cashForFirstTradesIndex;
            this._settings.SkippedTradeSolution = this._skippedTradeSolution;
            this._settings.PercentOfAverageVolume = this._percentOfAverageVolume;
            this._settings.DaysToAverage = this._daysToAverage;
            return this._settings;
        }

        public void ReadSettings(ISettingsHost host)
        {
            //base.ReadBasicSettings(host);
            string s = "PosSizer.Abacus.";
            this._fixedDollarChecked = host.Get(s + "FixedDollarChecked", (bool)true);
            this._fixedDollarValue = host.Get(s + "FixedDollarValue", (double)100000);
            this._percentOfCashChecked = host.Get(s + "PercentOfCashChecked", (bool)false);
            this._percentOfCashValue = host.Get(s + "PercentOfCashValue", (double)10);
            this._spreadCashEqually = host.Get(s + "SpreadCashEqually", (bool)false);
            this._cashForFirstTradesIndex = host.Get(s + "CashForFirstTradesIndex", (int)0);
            this._skippedTradeSolution = host.Get(s + "SkippedTradeSolution", (bool)false);
            this._percentOfAverageVolume = host.Get(s + "PercentOfAverageVolume", (double)1.5);
            this._daysToAverage = host.Get(s + "DaysToAverage", (int)10);
        }

        public void WriteSettings(ISettingsHost host)
        {
            //base.WriteBasicSettings(host);
            string s = "PosSizer.Abacus.";
            host.Set(s + "FixedDollarChecked", this._settings.FixedDollarChecked);
            host.Set(s + "FixedDollarValue", this._settings.FixedDollarValue);
            host.Set(s + "PercentOfCashChecked", this._settings.PercentOfCashChecked);
            host.Set(s + "PercentOfCashValue", this._percentOfCashValue);
            host.Set(s + "SpreadCashEqually", this._settings.SpreadCashEqually);
            host.Set(s + "CashForFirstTradesIndex", this._settings.CashForFirstTradesIndex);
            host.Set(s + "SkippedTradeSolution", this._settings.SkippedTradeSolution);
            host.Set(s + "PercentOfAverageVolume", this._percentOfAverageVolume);
            host.Set(s + "DaysToAverage", this._daysToAverage);
        }

        public override string FriendlyName
        {
            get
            {
                return "Abacus";
            }
        }
    }
}
